using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;

namespace OSI.API.Controllers
{
    public abstract class EndpointBase<A> : ControllerBase
    {
        [HttpGet]
        public abstract IActionResult Get();

        // GET: api/Clients/5
        [HttpGet("{id}")]
        public abstract IActionResult Get(int id);

        // POST: api/Clients
        [HttpPost]
        public abstract IActionResult Create([FromBody] A input);

        // PUT: api/Clients/5
        [HttpPut("{id}")]
        public abstract IActionResult Update([FromBody] A input);

        // DELETE: api/Clients/5
        [HttpDelete("{id}")]
        public abstract IActionResult Delete(int id);
    }
}